<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/24/2004 *
 * ===================                          Last change: 08/28/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-rewrite.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Rewrites own links for search engines            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Schreibt eigene Links um fuer Suchmaschinen      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.1.3');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9', '0.1.0', '0.1.1', '0.1.2', '0.1.3'));

// This extension is deprecated
// @TODO Only when 'seo' is ready: setExtensionDeprecated('Y');

switch (getExtensionMode()) {
	case 'setup': // Do stuff when installation is running
		// Check if mod_rewrite is loadeded
		if (!isApacheModuleLoaded('mod_rewrite')) {
			enableExtensionReportingFailure();
			addFatalMessage(__FILE__, __LINE__, '{--MOD_REWRITE_ERROR--}');
		} // END - if

		// SQL commands to run
		addExtensionSql('');
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what`='config_rewrite'");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// Check if mod_rewrite is loadeded
		if (!isApacheModuleLoaded('mod_rewrite')) {
			sqlQuery("UPDATE `{?_MYSQL_PREFIX?}_extensions` SET `ext_active`='N' WHERE `ext_name`='rewrite' LIMIT 1", __FILE__, __LINE__);
			enableExtensionReportingFailure();
			addFatalMessage(__FILE__, __LINE__, '{--MOD_REWRITE_ERROR--}');
	 } // END - if

	 // SQL commands to run
	 addExtensionSql('');
	 break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql('');
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Folgende Linkvariablen werden nun auch ausgetauscht: bid, mid, url, page, offset");
				break;

			case '0.0.2': // SQL queries for v0.0.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Folgende Linkvariablen werden nun auch ausgetauscht: type, do=search");

			case '0.0.3': // SQL queries for v0.0.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("URLs zu mxchange.org ({?SERVER_URL?}) sind nun auch wieder g&uuml;ltig.");
				break;

			case '0.0.4': // SQL queries for v0.0.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Folgende Linkvariablen werden nun auch ausgetausch: sub, home");
				break;

			case '0.0.5': // SQL queries for v0.0.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Links im Admin- und Mitgliedsbereich werden nicht mehr umgeschrieben. Entsprechend f&auml;llt die neue .htaccess-Datei kleiner aus. Bitte anpassen!");

			case '0.0.6': // SQL queries for v0.0.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Links im Frametester-Modul werden nicht mehr umgeschrieben.");
				break;

			case '0.0.7': // SQL queries for v0.0.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.0.8': // SQL queries for v0.0.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.0.9': // SQL queries for v0.0.9
				addConfigAddSql('rewrite_skip', "VARCHAR(255) NOT NULL DEFAULT 'login:admin:frametester:mailid'");
				addAdminMenuSql('setup','config_rewrite','Rewrite-Engine','Stellen Sie hier ein, welche Module &uuml;bersprungen werden sollen, in denen also kein Umschreiben des HTML-Codes stattfinden soll.', 8);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Zu &uuml;berspringende Module k&ouml;nnen per Admin-Bereich eingestellt werden.");
				break;

			case '0.1.0': // SQL queries for v0.2.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("W&ouml;rter <strong>{?mt_word?}</strong>, <strong>{?mt_word2?}</strong> und <strong>{?mt_word3?}</strong> sind austauschbar.");
				break;

			case '0.1.1': // SQL queries for v0.1.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.");
				break;

			case '0.1.2': // SQL queries for v0.1.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abspeichern von Einstellungen repariert.");
				break;
			case '0.1.3':
				// Check if mod_rewrite is loadeded
				if (!isApacheModuleLoaded('mod_rewrite')) {
					enableExtensionReportingFailure();
					//addFatalMessage(__FILE__, __LINE__, '{--MOD_REWRITE_ERROR--}');
				} // END - if
				setExtensionUpdateNotes("Es wird beim Registrieren und aktivieren gepr&uuml;ft, ob im Apache das Modul mod_rewrite geladen wurde. Wenn mod_rewrite nicht gefunden werden konnte, wird abgebrochen.");
				break;
		}
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		// Check if mod_rewrite is loadeded
		if (!isApacheModuleLoaded('mod_rewrite')) {
			enableExtensionReportingFailure();
			sqlQuery("UPDATE `{?_MYSQL_PREFIX?}_extensions` SET `ext_active`='N' WHERE `ext_name`='rewrite' LIMIT 1", __FILE__, __LINE__);
			if (!isAdmin()) {
				addFatalMessage(__FILE__, __LINE__, '{--MOD_REWRITE_ERROR--}');
			} // END - if
		} // END - if
		break;

	default: // Unknown extension mode
		reportBug(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
}

// [EOF]
?>
