<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/03/2011 *
 * ===================                          Last change: 08/03/2011 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : earning_filter.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Filters for ext-earning                          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Filter fuer ext-earning                          *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Filter function to add 'earning_group' POPUP
function FILTER_ADD_EARNING_GROUP_POPUP ($filterData) {
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Called!');
	// Check if the current userid is same as in $filterData
	if (getMemberId() != $filterData['userid']) {
		// Not the same
		reportBug(__FUNCTION__, __LINE__, 'Validation of userid failed. ' . getMemberId() . '!=' . $filterData['userid']);
	} // END - if

	// Now check if the user has subscription and amount left
	$result = sqlQueryEscaped("SELECT
	`d`.`earning_id`,
	`d`.`earning_provider`,
	`u`.`earning_current_amount`,
	`u`.`earning_daily_amount`,
	`u`.`earning_active`,
	`u`.`earning_added`,
	`u`.`earning_canceled`,
	`u`.`earning_points`
FROM
	`{?_MYSQL_PREFIX?}_user_earning` AS `u`
INNER JOIN
	`{?_MYSQL_PREFIX?}_earning_data` AS `d`
ON
	`u`.`earning_id`=`d`.`earning_id`
WHERE
	`u`.`earning_userid`=%s AND
	`u`.`earning_active`='Y' AND
	`u`.`earning_current_amount` < `u`.`earning_daily_amount` AND
	`d`.`earning_group`='POPUP'
ORDER BY
	`d`.`earning_sorting` ASC",
		array(
			getMemberId()
		), __FUNCTION__, __LINE__);

	// Are there entries left?
	if (!ifSqlHasZeroNums($result)) {
		// Load all names
		while ($content = sqlFetchArray($result)) {
			// Merge the $filterData array in
			$content = merge_array($content, $filterData);

			// Construct callback function name
			$callbackName = 'get' . capitalizeUnderscoreString($content['earning_provider']) . 'DataByEarningArray';

			/*
			 * And call it, the called function should NOT write data in
			 * '__output'. This however is done here in this function. The
			 * called function shall ALWAYS put it's data in '__data'.
			 */
			$content = call_user_func($callbackName, $content);
		} // END - if
	} // END - if

	// Free result
	sqlFreeResult($result);

	// Return filter data
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// [EOF]
?>
