<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/28/2003 *
 * ===================                          Last change: 05/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-memedit.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Edit member's menu                               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Editieren Sie das Menue fuer Ihre Mitglieder     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Do we edit/delete/change main menus or sub menus?
$AND = "(`what` = '' OR `what` IS NULL)"; $subMenu = '';

if (isGetRequestElementSet('sub')) {
	$AND = sprintf("`action`='%s' AND `what` IS NOT NULL", getRequestElement('sub'));
	$subMenu = getRequestElement('sub');
} // END - if

// List all menu points and make them editable
if ((isFormSent('edit')) && (ifPostContainsSelections()) && (!isDemoModeActive())) {
	// Edit menu entries
	$content['sub'] = $subMenu;
	$content['chk'] = countPostSelection();
	$count = '0'; $OUT = '';
	foreach (postRequestElement('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$count++;
			$result = sqlQueryEscaped("SELECT `title`, `action`, `what` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (sqlNumRows($result) == 1) {
				// Entry found so we load the stuff...
				$content = sqlFetchArray($result);
				$content = array(
					'count'  => $count,
					'sel'    => $sel,
					'menu'   => $content['title'],
					'action' => adminAddMenuSelectionBox('member', 'action', 'sel_action[' . $sel . ']', $content['action']),
					'what'   => adminAddMenuSelectionBox('member', 'what'  , 'sel_what[' . $sel . ']', $content['what']),
				);

				// Load template
				$OUT .= loadTemplate('admin_edit_member_menu_row', TRUE, $content);
			} else {
				// Entry not found?
				$content = array(
					'sel' => $sel
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_404_row', TRUE, $content);
			}
			sqlFreeResult($result);
		} // END - if
	} // END - foreach

	// Add row content and current counter
	$content['rows']  = $OUT;
	$content['chk']   = countPostSelection();
	$content['sub']   = $subMenu;
	$content['count'] = $count;

	// Load template
	loadTemplate('admin_edit_member_menu', FALSE, $content);
} elseif ((isFormSent('delete')) && (ifPostContainsSelections()) && (!isDemoModeActive())) {
	// Del menu entries with or without confirmation
	$content['sub'] = $subMenu;
	$content['chk'] = countPostSelection();
	$count = '0'; $OUT = '';
	foreach (postRequestElement('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$count++;
			$result = sqlQueryEscaped("SELECT `title` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (sqlNumRows($result) == 1) {
				// Entry found so we load the stuff...
				list($title) = sqlFetchRow($result);
				$content = array(
					'count' => $count,
					'sel'   => $sel,
					'title' => $title
				);

				// Load template
				$OUT .= loadTemplate('admin_delete_member_menu_row', TRUE, $content);
			} else {
				// Entry not found?
				$content = array(
					'sel' => $sel
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_404_row', TRUE, $content);
			}
			sqlFreeResult($result);
		} // END - if
	} // END - foreach

	$content['rows']  = $OUT;
	$content['chk']   = countPostSelection();
	$content['sub']   = $subMenu;
	$content['count'] = $count;

	// Load template
	loadTemplate('admin_delete_member_menu', FALSE, $content);
} elseif ((isPostRequestElementSet('status')) && (ifPostContainsSelections()) && (!isDemoModeActive())) {
	// Change status (visible / locked)
	$content['sub'] = $subMenu;
	$content['chk'] = countPostSelection();
	$count = '0'; $OUT = '';
	foreach (postRequestElement('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$count++;
			$result = sqlQueryEscaped("SELECT `title`, `visible`, `locked` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (sqlNumRows($result) == 1) {
				// Entry found so we load the stuff...
				$content = sqlFetchArray($result);
				$content = array(
					'count'   => $count,
					'menu'    => $content['title'],
					'sel'     => $sel,
					'visible' => addSelectionBox('yn', $content['visible'], 'visible', $sel),
					'locked'  => addSelectionBox('yn', $content['locked'] , 'locked' , $sel),
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_status_row', TRUE, $content);
			} else {
				// Entry not found?
				$content = array(
					'sel' => $sel
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_404_row', TRUE, $content);
			}
			sqlFreeResult($result);
		} // END - if
	} // END - foreach

	$content['rows']  = $OUT;
	$content['chk']   = countPostSelection();
	$content['sub']   = $subMenu;
	$content['count'] = $count;

	// Load template
	loadTemplate('admin_member_menu_status', FALSE, $content);
} elseif ((isFormSent()) && (!isDemoModeActive())) {
	// Process menu editing form
	adminProcessMenuEditForm('member', $subMenu);
} else {
	// Handle weightning
	doAdminProcessMenuWeightning('member', $AND);

	if (!empty($subMenu)) {
		// Edit sub menus
		$result = sqlQuery("SELECT `id`, `action`, `what`, `title`, `sort` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `what` != '' AND `what` IS NOT NULL ORDER BY `sort` ASC", __FILE__, __LINE__);
	} else {
		// Edit main menus
		$result = sqlQuery("SELECT `id`, `action`, `what`, `title`, `sort` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE (`what`='' OR `what` IS NULL) ORDER BY `sort` ASC", __FILE__, __LINE__);
	}

	// Some are there?
	if (!ifSqlHasZeroNums($result)) {
		$count = '0'; $OUT = '';
		while ($content = sqlFetchArray($result)) {
			// Set sub value
			$content['sub'] = $subMenu;

			// Init navigation
			$content['navi'] = '';
			$count++;
			if (($content['sort'] == '0') || (($content['sort'] == 1) && (!empty($subMenu)))) {
				// Is highest position
				$content['navi'] = '<a href="{%url=modules.php?module=admin&amp;what=memedit&amp;sub=' . $content['sub'] . '&amp;act=' . $content['action'] . '&amp;w=' . $content['what'] . '&amp;tid=' . ($content['sort']+1) . '&amp;fid=' . $content['sort'] . '%}">{--LOWER--}</a>';
			} elseif ($count == sqlNumRows($result)) {
				// Is lowest position
				$content['navi'] = '<a href="{%url=modules.php?module=admin&amp;what=memedit&amp;sub=' . $content['sub'] . '&amp;act=' . $content['action'] . '&amp;w=' . $content['what'] . '&amp;tid=' . ($content['sort']-1) . '&amp;fid=' . $content['sort'] . '%}">{--HIGHER--}</a>';
			} elseif ($content['sort'] > 0) {
				// Anything else between highest and lowest
				$content['navi'] = '<a href="{%url=modules.php?module=admin&amp;what=memedit&amp;sub=' . $content['sub'] . '&amp;act=' . $content['action'] . '&amp;w=' . $content['what'] . '&amp;tid=' . ($content['sort']-1) . '&amp;fid=' . $content['sort'] . '%}">{--HIGHER--}</a>|<a href="{%url=modules.php?module=admin&amp;what=memedit&amp;sub=' . $content['sub'] . '&amp;act=' . $content['action'] . '&amp;w=' . $content['what'] . '&amp;tid=' . ($content['sort']+1) . '&amp;fid=' . $content['sort'] . '%}">{--LOWER--}</a>';
			}

			// Add more entries
			$content['do'] = 'mem';

			// Load row template and switch color
			$OUT .= loadTemplate('admin_menu_overview_row', TRUE, $content);
		} // END - while

		// Free memory
		sqlFreeResult($result);

		// Remember rows/sub in array
		$content['rows'] = $OUT;
		$content['sub']  = $subMenu;

		// Load main template
		loadTemplate('admin_member_menu_overview', FALSE, $content);
	} else {
		// Menu entries are missing... (???)
		displayMessage('{--ADMIN_NO_MENUS_FOUND--}');
	}
}

// [EOF]
?>
